from enum import Enum


class EventTypesEnum(str, Enum):
    ACCESS_SUBNET_CREATION_SUCCEEDED = "access_subnet_creation_succeeded"
    ACCESS_SUBNET_DELETION_SUCCEEDED = "access_subnet_deletion_succeeded"
    ACCESS_SUBNET_UPDATE_SUCCEEDED = "access_subnet_update_succeeded"
    ALLOWED_OFFERINGS_HAVE_BEEN_UPDATED = "allowed_offerings_have_been_updated"
    ATTACHMENT_CREATED = "attachment_created"
    ATTACHMENT_DELETED = "attachment_deleted"
    ATTACHMENT_UPDATED = "attachment_updated"
    AUTH_LOGGED_IN_WITH_OAUTH = "auth_logged_in_with_oauth"
    AUTH_LOGGED_IN_WITH_SAML2 = "auth_logged_in_with_saml2"
    AUTH_LOGGED_IN_WITH_USERNAME = "auth_logged_in_with_username"
    AUTH_LOGGED_OUT = "auth_logged_out"
    AUTH_LOGGED_OUT_WITH_SAML2 = "auth_logged_out_with_saml2"
    AUTH_LOGIN_FAILED_WITH_USERNAME = "auth_login_failed_with_username"
    BLOCK_CREATION_OF_NEW_RESOURCES = "block_creation_of_new_resources"
    BLOCK_MODIFICATION_OF_EXISTING_RESOURCES = "block_modification_of_existing_resources"
    CALL_DOCUMENT_ADDED = "call_document_added"
    CALL_DOCUMENT_REMOVED = "call_document_removed"
    CREATE_OF_CREDIT_BY_STAFF = "create_of_credit_by_staff"
    CUSTOMER_CREATION_SUCCEEDED = "customer_creation_succeeded"
    CUSTOMER_DELETION_SUCCEEDED = "customer_deletion_succeeded"
    CUSTOMER_UPDATE_SUCCEEDED = "customer_update_succeeded"
    CUSTOM_NOTIFICATION = "custom_notification"
    DROPLET_RESIZE_SCHEDULED = "droplet_resize_scheduled"
    DROPLET_RESIZE_SUCCEEDED = "droplet_resize_succeeded"
    FREEIPA_PROFILE_CREATED = "freeipa_profile_created"
    FREEIPA_PROFILE_DELETED = "freeipa_profile_deleted"
    FREEIPA_PROFILE_DISABLED = "freeipa_profile_disabled"
    FREEIPA_PROFILE_ENABLED = "freeipa_profile_enabled"
    INVOICE_CANCELED = "invoice_canceled"
    INVOICE_CREATED = "invoice_created"
    INVOICE_ITEM_CREATED = "invoice_item_created"
    INVOICE_ITEM_DELETED = "invoice_item_deleted"
    INVOICE_ITEM_UPDATED = "invoice_item_updated"
    INVOICE_PAID = "invoice_paid"
    ISSUE_CREATION_SUCCEEDED = "issue_creation_succeeded"
    ISSUE_DELETION_SUCCEEDED = "issue_deletion_succeeded"
    ISSUE_UPDATE_SUCCEEDED = "issue_update_succeeded"
    MARKETPLACE_OFFERING_COMPONENT_CREATED = "marketplace_offering_component_created"
    MARKETPLACE_OFFERING_COMPONENT_DELETED = "marketplace_offering_component_deleted"
    MARKETPLACE_OFFERING_COMPONENT_UPDATED = "marketplace_offering_component_updated"
    MARKETPLACE_OFFERING_CREATED = "marketplace_offering_created"
    MARKETPLACE_OFFERING_ROLE_CREATED = "marketplace_offering_role_created"
    MARKETPLACE_OFFERING_ROLE_DELETED = "marketplace_offering_role_deleted"
    MARKETPLACE_OFFERING_ROLE_UPDATED = "marketplace_offering_role_updated"
    MARKETPLACE_OFFERING_UPDATED = "marketplace_offering_updated"
    MARKETPLACE_OFFERING_USER_CREATED = "marketplace_offering_user_created"
    MARKETPLACE_OFFERING_USER_DELETED = "marketplace_offering_user_deleted"
    MARKETPLACE_OFFERING_USER_RESTRICTION_UPDATED = "marketplace_offering_user_restriction_updated"
    MARKETPLACE_ORDER_APPROVED = "marketplace_order_approved"
    MARKETPLACE_ORDER_COMPLETED = "marketplace_order_completed"
    MARKETPLACE_ORDER_CREATED = "marketplace_order_created"
    MARKETPLACE_ORDER_FAILED = "marketplace_order_failed"
    MARKETPLACE_ORDER_REJECTED = "marketplace_order_rejected"
    MARKETPLACE_ORDER_TERMINATED = "marketplace_order_terminated"
    MARKETPLACE_ORDER_UNLINKED = "marketplace_order_unlinked"
    MARKETPLACE_PLAN_ARCHIVED = "marketplace_plan_archived"
    MARKETPLACE_PLAN_COMPONENT_CURRENT_PRICE_UPDATED = "marketplace_plan_component_current_price_updated"
    MARKETPLACE_PLAN_COMPONENT_FUTURE_PRICE_UPDATED = "marketplace_plan_component_future_price_updated"
    MARKETPLACE_PLAN_COMPONENT_QUOTA_UPDATED = "marketplace_plan_component_quota_updated"
    MARKETPLACE_PLAN_CREATED = "marketplace_plan_created"
    MARKETPLACE_PLAN_UPDATED = "marketplace_plan_updated"
    MARKETPLACE_RESOURCE_CREATE_CANCELED = "marketplace_resource_create_canceled"
    MARKETPLACE_RESOURCE_CREATE_FAILED = "marketplace_resource_create_failed"
    MARKETPLACE_RESOURCE_CREATE_REQUESTED = "marketplace_resource_create_requested"
    MARKETPLACE_RESOURCE_CREATE_SUCCEEDED = "marketplace_resource_create_succeeded"
    MARKETPLACE_RESOURCE_DOWNSCALED = "marketplace_resource_downscaled"
    MARKETPLACE_RESOURCE_ERRED_ON_BACKEND = "marketplace_resource_erred_on_backend"
    MARKETPLACE_RESOURCE_PAUSED = "marketplace_resource_paused"
    MARKETPLACE_RESOURCE_TERMINATE_CANCELED = "marketplace_resource_terminate_canceled"
    MARKETPLACE_RESOURCE_TERMINATE_FAILED = "marketplace_resource_terminate_failed"
    MARKETPLACE_RESOURCE_TERMINATE_REQUESTED = "marketplace_resource_terminate_requested"
    MARKETPLACE_RESOURCE_TERMINATE_SUCCEEDED = "marketplace_resource_terminate_succeeded"
    MARKETPLACE_RESOURCE_UNLINKED = "marketplace_resource_unlinked"
    MARKETPLACE_RESOURCE_UPDATE_CANCELED = "marketplace_resource_update_canceled"
    MARKETPLACE_RESOURCE_UPDATE_END_DATE_SUCCEEDED = "marketplace_resource_update_end_date_succeeded"
    MARKETPLACE_RESOURCE_UPDATE_FAILED = "marketplace_resource_update_failed"
    MARKETPLACE_RESOURCE_UPDATE_LIMITS_FAILED = "marketplace_resource_update_limits_failed"
    MARKETPLACE_RESOURCE_UPDATE_LIMITS_SUCCEEDED = "marketplace_resource_update_limits_succeeded"
    MARKETPLACE_RESOURCE_UPDATE_REQUESTED = "marketplace_resource_update_requested"
    MARKETPLACE_RESOURCE_UPDATE_SUCCEEDED = "marketplace_resource_update_succeeded"
    MARKETPLACE_RESOURCE_USER_CREATED = "marketplace_resource_user_created"
    MARKETPLACE_RESOURCE_USER_DELETED = "marketplace_resource_user_deleted"
    NOTIFY_EXTERNAL_USER = "notify_external_user"
    NOTIFY_ORGANIZATION_OWNERS = "notify_organization_owners"
    NOTIFY_PROJECT_TEAM = "notify_project_team"
    OPENSTACK_FLOATING_IP_ATTACHED = "openstack_floating_ip_attached"
    OPENSTACK_FLOATING_IP_CONNECTED = "openstack_floating_ip_connected"
    OPENSTACK_FLOATING_IP_DESCRIPTION_UPDATED = "openstack_floating_ip_description_updated"
    OPENSTACK_FLOATING_IP_DETACHED = "openstack_floating_ip_detached"
    OPENSTACK_FLOATING_IP_DISCONNECTED = "openstack_floating_ip_disconnected"
    OPENSTACK_NETWORK_CLEANED = "openstack_network_cleaned"
    OPENSTACK_NETWORK_CREATED = "openstack_network_created"
    OPENSTACK_NETWORK_DELETED = "openstack_network_deleted"
    OPENSTACK_NETWORK_IMPORTED = "openstack_network_imported"
    OPENSTACK_NETWORK_PULLED = "openstack_network_pulled"
    OPENSTACK_NETWORK_UPDATED = "openstack_network_updated"
    OPENSTACK_PORT_CLEANED = "openstack_port_cleaned"
    OPENSTACK_PORT_CREATED = "openstack_port_created"
    OPENSTACK_PORT_DELETED = "openstack_port_deleted"
    OPENSTACK_PORT_IMPORTED = "openstack_port_imported"
    OPENSTACK_PORT_PULLED = "openstack_port_pulled"
    OPENSTACK_PORT_UPDATED = "openstack_port_updated"
    OPENSTACK_ROUTER_UPDATED = "openstack_router_updated"
    OPENSTACK_SECURITY_GROUP_CLEANED = "openstack_security_group_cleaned"
    OPENSTACK_SECURITY_GROUP_CREATED = "openstack_security_group_created"
    OPENSTACK_SECURITY_GROUP_DELETED = "openstack_security_group_deleted"
    OPENSTACK_SECURITY_GROUP_IMPORTED = "openstack_security_group_imported"
    OPENSTACK_SECURITY_GROUP_PULLED = "openstack_security_group_pulled"
    OPENSTACK_SECURITY_GROUP_RULE_CLEANED = "openstack_security_group_rule_cleaned"
    OPENSTACK_SECURITY_GROUP_RULE_CREATED = "openstack_security_group_rule_created"
    OPENSTACK_SECURITY_GROUP_RULE_DELETED = "openstack_security_group_rule_deleted"
    OPENSTACK_SECURITY_GROUP_RULE_IMPORTED = "openstack_security_group_rule_imported"
    OPENSTACK_SECURITY_GROUP_RULE_UPDATED = "openstack_security_group_rule_updated"
    OPENSTACK_SECURITY_GROUP_UPDATED = "openstack_security_group_updated"
    OPENSTACK_SERVER_GROUP_CLEANED = "openstack_server_group_cleaned"
    OPENSTACK_SERVER_GROUP_CREATED = "openstack_server_group_created"
    OPENSTACK_SERVER_GROUP_DELETED = "openstack_server_group_deleted"
    OPENSTACK_SERVER_GROUP_IMPORTED = "openstack_server_group_imported"
    OPENSTACK_SERVER_GROUP_PULLED = "openstack_server_group_pulled"
    OPENSTACK_SUBNET_CLEANED = "openstack_subnet_cleaned"
    OPENSTACK_SUBNET_CREATED = "openstack_subnet_created"
    OPENSTACK_SUBNET_DELETED = "openstack_subnet_deleted"
    OPENSTACK_SUBNET_IMPORTED = "openstack_subnet_imported"
    OPENSTACK_SUBNET_PULLED = "openstack_subnet_pulled"
    OPENSTACK_SUBNET_UPDATED = "openstack_subnet_updated"
    OPENSTACK_TENANT_QUOTA_LIMIT_UPDATED = "openstack_tenant_quota_limit_updated"
    PAYMENT_ADDED = "payment_added"
    PAYMENT_CREATED = "payment_created"
    PAYMENT_REMOVED = "payment_removed"
    POLICY_NOTIFICATION = "policy_notification"
    PROJECT_CREATION_SUCCEEDED = "project_creation_succeeded"
    PROJECT_DELETION_SUCCEEDED = "project_deletion_succeeded"
    PROJECT_DELETION_TRIGGERED = "project_deletion_triggered"
    PROJECT_UPDATE_REQUEST_APPROVED = "project_update_request_approved"
    PROJECT_UPDATE_REQUEST_CREATED = "project_update_request_created"
    PROJECT_UPDATE_REQUEST_REJECTED = "project_update_request_rejected"
    PROJECT_UPDATE_SUCCEEDED = "project_update_succeeded"
    PROPOSAL_CANCELED = "proposal_canceled"
    PROPOSAL_DOCUMENT_ADDED = "proposal_document_added"
    PROPOSAL_DOCUMENT_REMOVED = "proposal_document_removed"
    QUERY_EXECUTED = "query_executed"
    REDUCTION_OF_CUSTOMER_CREDIT = "reduction_of_customer_credit"
    REDUCTION_OF_CUSTOMER_CREDIT_DUE_TO_MINIMAL_CONSUMPTION = "reduction_of_customer_credit_due_to_minimal_consumption"
    REDUCTION_OF_CUSTOMER_EXPECTED_CONSUMPTION = "reduction_of_customer_expected_consumption"
    REDUCTION_OF_PROJECT_CREDIT = "reduction_of_project_credit"
    REDUCTION_OF_PROJECT_CREDIT_DUE_TO_MINIMAL_CONSUMPTION = "reduction_of_project_credit_due_to_minimal_consumption"
    REDUCTION_OF_PROJECT_EXPECTED_CONSUMPTION = "reduction_of_project_expected_consumption"
    REQUEST_DOWNSCALING = "request_downscaling"
    REQUEST_PAUSING = "request_pausing"
    RESOURCE_ASSIGN_FLOATING_IP_FAILED = "resource_assign_floating_ip_failed"
    RESOURCE_ASSIGN_FLOATING_IP_SCHEDULED = "resource_assign_floating_ip_scheduled"
    RESOURCE_ASSIGN_FLOATING_IP_SUCCEEDED = "resource_assign_floating_ip_succeeded"
    RESOURCE_ATTACH_FAILED = "resource_attach_failed"
    RESOURCE_ATTACH_SCHEDULED = "resource_attach_scheduled"
    RESOURCE_ATTACH_SUCCEEDED = "resource_attach_succeeded"
    RESOURCE_BACKUP_CREATION_FAILED = "resource_backup_creation_failed"
    RESOURCE_BACKUP_CREATION_SCHEDULED = "resource_backup_creation_scheduled"
    RESOURCE_BACKUP_CREATION_SUCCEEDED = "resource_backup_creation_succeeded"
    RESOURCE_BACKUP_DELETION_FAILED = "resource_backup_deletion_failed"
    RESOURCE_BACKUP_DELETION_SCHEDULED = "resource_backup_deletion_scheduled"
    RESOURCE_BACKUP_DELETION_SUCCEEDED = "resource_backup_deletion_succeeded"
    RESOURCE_BACKUP_RESTORATION_FAILED = "resource_backup_restoration_failed"
    RESOURCE_BACKUP_RESTORATION_SCHEDULED = "resource_backup_restoration_scheduled"
    RESOURCE_BACKUP_RESTORATION_SUCCEEDED = "resource_backup_restoration_succeeded"
    RESOURCE_CHANGE_FLAVOR_FAILED = "resource_change_flavor_failed"
    RESOURCE_CHANGE_FLAVOR_SCHEDULED = "resource_change_flavor_scheduled"
    RESOURCE_CHANGE_FLAVOR_SUCCEEDED = "resource_change_flavor_succeeded"
    RESOURCE_CREATION_FAILED = "resource_creation_failed"
    RESOURCE_CREATION_SCHEDULED = "resource_creation_scheduled"
    RESOURCE_CREATION_SUCCEEDED = "resource_creation_succeeded"
    RESOURCE_DELETION_FAILED = "resource_deletion_failed"
    RESOURCE_DELETION_SCHEDULED = "resource_deletion_scheduled"
    RESOURCE_DELETION_SUCCEEDED = "resource_deletion_succeeded"
    RESOURCE_DETACH_FAILED = "resource_detach_failed"
    RESOURCE_DETACH_SCHEDULED = "resource_detach_scheduled"
    RESOURCE_DETACH_SUCCEEDED = "resource_detach_succeeded"
    RESOURCE_EXTEND_FAILED = "resource_extend_failed"
    RESOURCE_EXTEND_SCHEDULED = "resource_extend_scheduled"
    RESOURCE_EXTEND_SUCCEEDED = "resource_extend_succeeded"
    RESOURCE_EXTEND_VOLUME_FAILED = "resource_extend_volume_failed"
    RESOURCE_EXTEND_VOLUME_SCHEDULED = "resource_extend_volume_scheduled"
    RESOURCE_EXTEND_VOLUME_SUCCEEDED = "resource_extend_volume_succeeded"
    RESOURCE_IMPORT_SUCCEEDED = "resource_import_succeeded"
    RESOURCE_PULL_FAILED = "resource_pull_failed"
    RESOURCE_PULL_SCHEDULED = "resource_pull_scheduled"
    RESOURCE_PULL_SUCCEEDED = "resource_pull_succeeded"
    RESOURCE_RESTART_FAILED = "resource_restart_failed"
    RESOURCE_RESTART_SCHEDULED = "resource_restart_scheduled"
    RESOURCE_RESTART_SUCCEEDED = "resource_restart_succeeded"
    RESOURCE_RETYPE_FAILED = "resource_retype_failed"
    RESOURCE_RETYPE_SCHEDULED = "resource_retype_scheduled"
    RESOURCE_RETYPE_SUCCEEDED = "resource_retype_succeeded"
    RESOURCE_ROBOT_ACCOUNT_CREATED = "resource_robot_account_created"
    RESOURCE_ROBOT_ACCOUNT_DELETED = "resource_robot_account_deleted"
    RESOURCE_ROBOT_ACCOUNT_STATE_CHANGED = "resource_robot_account_state_changed"
    RESOURCE_ROBOT_ACCOUNT_UPDATED = "resource_robot_account_updated"
    RESOURCE_START_FAILED = "resource_start_failed"
    RESOURCE_START_SCHEDULED = "resource_start_scheduled"
    RESOURCE_START_SUCCEEDED = "resource_start_succeeded"
    RESOURCE_STOP_FAILED = "resource_stop_failed"
    RESOURCE_STOP_SCHEDULED = "resource_stop_scheduled"
    RESOURCE_STOP_SUCCEEDED = "resource_stop_succeeded"
    RESOURCE_UNASSIGN_FLOATING_IP_FAILED = "resource_unassign_floating_ip_failed"
    RESOURCE_UNASSIGN_FLOATING_IP_SCHEDULED = "resource_unassign_floating_ip_scheduled"
    RESOURCE_UNASSIGN_FLOATING_IP_SUCCEEDED = "resource_unassign_floating_ip_succeeded"
    RESOURCE_UPDATE_ALLOWED_ADDRESS_PAIRS_FAILED = "resource_update_allowed_address_pairs_failed"
    RESOURCE_UPDATE_ALLOWED_ADDRESS_PAIRS_SCHEDULED = "resource_update_allowed_address_pairs_scheduled"
    RESOURCE_UPDATE_ALLOWED_ADDRESS_PAIRS_SUCCEEDED = "resource_update_allowed_address_pairs_succeeded"
    RESOURCE_UPDATE_FLOATING_IPS_FAILED = "resource_update_floating_ips_failed"
    RESOURCE_UPDATE_FLOATING_IPS_SCHEDULED = "resource_update_floating_ips_scheduled"
    RESOURCE_UPDATE_FLOATING_IPS_SUCCEEDED = "resource_update_floating_ips_succeeded"
    RESOURCE_UPDATE_PORTS_FAILED = "resource_update_ports_failed"
    RESOURCE_UPDATE_PORTS_SCHEDULED = "resource_update_ports_scheduled"
    RESOURCE_UPDATE_PORTS_SUCCEEDED = "resource_update_ports_succeeded"
    RESOURCE_UPDATE_SECURITY_GROUPS_FAILED = "resource_update_security_groups_failed"
    RESOURCE_UPDATE_SECURITY_GROUPS_SCHEDULED = "resource_update_security_groups_scheduled"
    RESOURCE_UPDATE_SECURITY_GROUPS_SUCCEEDED = "resource_update_security_groups_succeeded"
    RESOURCE_UPDATE_SUCCEEDED = "resource_update_succeeded"
    RESTRICT_MEMBERS = "restrict_members"
    REVIEW_CANCELED = "review_canceled"
    ROLE_GRANTED = "role_granted"
    ROLE_REVOKED = "role_revoked"
    ROLE_UPDATED = "role_updated"
    ROLL_BACK_CUSTOMER_CREDIT = "roll_back_customer_credit"
    ROLL_BACK_PROJECT_CREDIT = "roll_back_project_credit"
    SERVICE_ACCOUNT_CREATED = "service_account_created"
    SERVICE_ACCOUNT_DELETED = "service_account_deleted"
    SERVICE_ACCOUNT_UPDATED = "service_account_updated"
    SET_TO_ZERO_OVERDUE_CREDIT = "set_to_zero_overdue_credit"
    SSH_KEY_CREATION_SUCCEEDED = "ssh_key_creation_succeeded"
    SSH_KEY_DELETION_SUCCEEDED = "ssh_key_deletion_succeeded"
    TERMINATE_RESOURCES = "terminate_resources"
    TOKEN_CREATED = "token_created"
    TOKEN_LIFETIME_UPDATED = "token_lifetime_updated"
    UPDATE_OF_CREDIT_BY_STAFF = "update_of_credit_by_staff"
    USER_ACTIVATED = "user_activated"
    USER_CREATION_SUCCEEDED = "user_creation_succeeded"
    USER_DEACTIVATED = "user_deactivated"
    USER_DELETION_SUCCEEDED = "user_deletion_succeeded"
    USER_DETAILS_UPDATE_SUCCEEDED = "user_details_update_succeeded"
    USER_HAS_BEEN_CREATED_BY_STAFF = "user_has_been_created_by_staff"
    USER_PASSWORD_UPDATED = "user_password_updated"
    USER_PASSWORD_UPDATED_BY_STAFF = "user_password_updated_by_staff"
    USER_UPDATE_SUCCEEDED = "user_update_succeeded"

    def __str__(self) -> str:
        return str(self.value)
